;; parcours en profondeur d'abord

(load "tda-arbre.scm")

(load "tda-pile.scm")

(define (empiler-list l p)
  (if (null? l)
      p
      (empiler (car l) (empiler-list (cdr l) p))))

(define (profondeur a)
  (define (prof L p)
    (if (pile-vide? p)
        L
        (let ( (abr (sommet p)) )
          (if (feuille? abr)
              (prof (cons (racine abr) L) (depiler p))
              (prof (cons (racine abr) L) (empiler-list (fils abr) (depiler p)))))))
  (prof '() (empiler a (pile-vide))))

;; arbre de test
(define abr 
  (cons-arbre 1 
   (list (cons-arbre 11 (list (feuille 21) (feuille 22) (feuille 23)))
         (feuille 12))))

(profondeur abr)