
;; TDA arbre N-aire

;; construit un arbre à partir de la valeur du noeud et de la liste des arbres fils
(define (cons-arbre e f)
  (cons e f))

;; valeur de la racine
(define (racine a)
  (if (not (null? a))
      (car a)
      '()))

;; liste des fils
(define (fils a)
  (if (null? a)
      '()
      (cdr a)))

;; l'arbre vide
(define (arbre-vide)
  '())

;; test de l'arbre vide
(define (arbre-vide? a)
  (null? a))

;; construit une feuille
(define (feuille e)
  (list e '()))

;; test de feuille
(define (feuille? a)
  (if (null? a)
      #f
      (null? (cdr a))))

;; ajout d'un fils à la liste des arbre fils
(define (cons-fils a f)
  (if (null? a)
      a
      (list (car a) (cons f (cadr a)))))

;; arbre de test
(define abr 
  (cons-fils 
   (cons-fils (feuille 1)
              (cons-fils (cons-fils (cons-fils (feuille 12) (feuille 23)) (feuille 22)) (feuille 21)))
   (feuille 11)))

;; TDA file




